#---------------------------------------------------
# Limo WEB-BBS System.
#   Hierarchy class - ҥ륭饹
#       ƥϢȤĴ٤֤
#
#                      1st Maintaner   Rero2@fumi.
#
#---------------------------------------------------

#------------------------------------
# 
# $Id: bbs_hierarchy.rb,v 1.6 2002/05/28 17:30:14 rero2 Exp $
#
# May.23.2002 - rero2@fumi
#   ϰɽȥڡɽ
# May.22.2002 - rero2@fumi
#   ȥԥåФҥ륭κ
# Feb.01.2002 - rero2@fumi
#   Article  ArticleClass ѹ
# Jan.13.2002 - rero2@fumi
#   ϡޤϿΤ (^^;
#
#----

#---------------------------------------------------
# 饤֥䳰ե
#---------------------------------------------------

require "config.rb"
require "bbs_database.rb"
require "bbs_article.rb"

#---------------------------------------------------
# 
#---------------------------------------------------

#-----------------------------------------------------
# 饹
#-----------------------------------------------------

#---------------------------------------------
#----- Hierarchy ܥ饹
#
class  Hierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  def initialize(db)
    @bbs_db = db
    @length = 0
    @relation = Array::new
  end


  #-------------------------------------
  #--- ƥ֤
  def length
    @length
  end

  alias size length


  #-------------------------------------
  #--- Ϣȥƥ֤
  #  num = ɤ߽Фƥ
  def get_article(num)
    @relation[num]
  end

end


#---------------------------------------------
#----- ǿ񤭹ߥꥹ
#
class  NewArticle < Hierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  #  num = ǿĤФ
  #  page = ɽڡ(0 Ǻǿ)
  def initialize(db, num, page)
    # --- ƥ饹θƤӽФ
    super(db)
    # --- Ϣɤ߽Ф᥽å
    listup(num, (num * page))
  end

  #- - - - - ʲץ饤١ȥꥢ
  private

  #-------------------------------------
  #--- ǡ򿷤Ф
  def listup(num, start)
    max = @bbs_db.length
    if start >= max then
      start = max - 1
    end
    if (start+num) < max then
      index = num + start
    else
      index = max
    end
    for i in start...index
      art = ArticleClass::new(@bbs_db)
      art.get_article(max-i-1)
      @relation << art
      @length += 1
    end
  end
  
end



#---------------------------------------------
#----- ƥϰϻȴФ
#
class  OnlyArticle < Hierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  #  area = ϰϻ
  #  max = 祢ƥ
  def initialize(db, area, max)
    # --- ƥ饹θƤӽФ
    super(db)
    # --- ޶ڤϤ줾¹
    segment = area.split(',')
    segment.each do |index|
      if index =~ /([0-9]*)-([0-9]*)/ then
        # -- ϰϻ
	start = $1.to_i
        toend = $2.to_i
        if start == 0 then
          start = 1
        end
        if toend == 0 then
          toend = db.length
        end
        if start > toend then
          tmp = start
          start = toend
          toend = tmp
        end
        # -- ϰϷ֤
        for id in start..toend
          art = ArticleClass::new(@bbs_db)
          art.get_article(id - 1)
          @relation << art
          @length += 1
          break if @length >= max
        end
      else
        # -- ñȥƥ
        art = ArticleClass::new(@bbs_db)
        art.get_article(index.to_i - 1)
        @relation << art
        @length += 1
        break if @length >= max
      end
      break if @length >= max
    end
    # --- ǡ֤
    @relation
  end
  
end



#---------------------------------------------
#----- ȥԥåХꥹ
#
class  TopicArticle < Hierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  #  num = ĤФ
  #  item = Фȥԥå̾(ܸ쥳 EUC)
  def initialize(db, num, item)
    # --- ƥ饹θƤӽФ
    super(db)
    # --- Ϣɤ߽Ф᥽å
    listup(num, item)
  end

  #- - - - - ʲץ饤١ȥꥢ
  private

  #-------------------------------------
  #--- ȥԥåΥƥ
  def listup(num, item)
    max = @bbs_db.length
    count = 0
    for i in 0...max
      art = ArticleClass::new(@bbs_db)
      art.get_article(max-1-i)
      if art.topic == item then
        @relation << art
        @length += 1
        count += 1
        break if count >= num
      end
    end
  end
  
end



