#!/usr/bin/ruby
#---------------------------------------------------
# Limo WEB-BBS System.
#   Post cgi - ƥ󥿡ե
#
#                      1st Maintaner   Rero2@fumi.
#
#---------------------------------------------------

#------------------------------------
# 
# $Id: diary_post.cgi,v 1.1 2002/09/21 09:11:22 rero2 Exp $
#
# Sep.16.2002 - rero2@fumi
#   ϡ
#
#----

require 'cgi'
require 'jcode'
require 'kconv'
require "config.rb"
require "bbs_database.rb"
require "diaryview.rb"

form_error = false
error_word = Array::new

# -----------------------------------------
# --- ե뤬äɤ߹
#
listicon = Hash::new
iconnum = 0;
if (Iconlist != '') && (File::exist?(Iconlist)) then
  File.foreach(Iconlist) do |line|
    itemcheck = line.split(',')
    if itemcheck.size == 2 then
      # --- ԤȤȤǥϥåѤ
      listicon[iconnum] = itemcheck[0]
	iconnum += 1
    end
  end
end

# --- CGI 󥿡ե
input = CGI.new

post_mode = String::new(input["mode"][0])
if post_mode == "NEW" then
  editmode = false
else
  editmode = true
end
passwd = String::new(input["passwd"][0])
serial = String::new(input["serial"][0]).to_i
topic = String::new(input["topic"][0])
title = String::new(input["title"][0])
author = String::new(input["author"][0])
reference = String::new(input["reference"][0])
icon = String::new(input["icon"][0])
talk = String::new(input["talk"][0])


# --- ʸ
topic.gsub!(/&/, '&amp;')
title.gsub!(/&/, '&amp;')
author.gsub!(/&/, '&amp;')
reference.gsub!(/&/, '&amp;')
talk.gsub!(/&/, '&amp;')
topic.gsub!(/^ /, '')
title.gsub!(/^ /, '')
author.gsub!(/^ /, '')
reference.gsub!(/^ /, '')
icon.gsub!(/^ /, '')
talk.gsub!(/^ /, '')
topic.gsub!(/ /, '&#32;')
title.gsub!(/ /, '&#32;')
author.gsub!(/ /, '&#32;')
reference.gsub!(/ /, '&#32;')
icon.gsub!(/ /, '&#32;')
talk.gsub!(/ /, '&#32;')
reference.gsub!(/\n/, "&#10;\n")
reference.gsub!(/\r/, '')
talk.gsub!(/\n/, "&#10;\n")
talk.gsub!(/\r/, '')
topic.gsub!(/</, '&lt;')
topic.gsub!(/>/, '&gt;')
title.gsub!(/</, '&lt;')
title.gsub!(/>/, '&gt;')
author.gsub!(/</, '&lt;')
author.gsub!(/>/, '&gt;')
reference.gsub!(/</, '&lt;')
reference.gsub!(/>/, '&gt;')
talk.gsub!(/</, '&lt;')
talk.gsub!(/>/, '&gt;')

# --- ̵
if icon == "null" then
  icon = ''
end

# --- ƥ
db = Diarydb::new(Datadir, Dataname)
art = DiaryArticle::new(db)


# --- ͭԤγǧ
userinfo = db.user_info(author)
if userinfo == nil then
  error_word << "ϿƤʤ桼Ǥ"
  form_error = true
end

# --- ܿͳǧΤΥѥǧ
crypt2 = passwd.crypt(Cryptsalt)
if userinfo !=nil then
  if userinfo[1] != crypt2 then
    error_word << "桼ѥɤǤ"
    form_error = true
  end
end


# --- Խ⡼ɤäѥɳǧ
if post_mode == "EDIT"
  art.get_article(serial-1)
  crypt1 = art.get_crypt
  crypt2 = passwd.crypt(Cryptsalt)
  unless crypt1 == crypt2 then
    error_word << "ԽΤΥѥɤǤ"
    form_error = true
  end
end

# --- 񤭹߲ǽɤåȥ顼
if (topic.length == 0)
  error_word << "ȥԥåϤƤޤ\n"
  form_error = true
end
if (title.length == 0)
  error_word << "ȥ뤬ϤƤޤ\n"
  form_error = true
end
if (author.length == 0)
  error_word << "Ҽ̾ϤƤޤ\n"
  form_error = true
end
if (talk.length == 0)
  error_word << "ʸϤƤޤ\n"
  form_error = true
end
if (passwd.length == 0)
  error_word << "ԽѥѥɤϤƤޤ\n"
  form_error = true
end
if form_error == true then
  print "Content-type: text/html\n\n"
  print "<HTML>\n"
  print "<HEAD>\n"
  print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=x-euc\">"
  print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"15;URL="+PostDiarydone+"\">"
  print "</HEAD>\n"
  print "<body>"
  print "<A HREF=\""+PostDiarydone+"\">Return BBS.</A>"
  print "<P><HR><P>\n"
  error_word.each do |err|
    print err+"<BR>\n"
  end
  print "</body></html>\n"
  exit
end


# --- ǶεҤƵȤ
antenna = db.antenna(author)
if antenna != nil then
  before = sprintf("@%d", antenna[1].to_i)
else
  before = '';
end

# --- ǡ١åΥå
while(db.lock_check == 1)
  sleep(0.5)
end

# --- ƥ˵ơԽ
if post_mode == "NEW" then
  serial = db.length
  art.set_crypt(passwd.crypt(Cryptsalt))
end
art.set_layer('diary')
art.set_serial(serial)
art.set_topic(topic)
art.set_parent(before)
art.set_title(Kconv::toeuc(title))
art.set_author(Kconv::toeuc(author))
art.set_reference(Kconv::toeuc(reference))
if icon.to_i > 0 then
  art.set_icon(Kconv::toeuc(listicon[icon.to_i]))
end
art.set_talk(Kconv::toeuc(talk))

# --- Ž񤭹ߥå
writeover = topic + title + author + talk + passwd
l = sprintf("len=%d", writeover.length)
writeover_key = l.crypt(Cryptsalt)
check_file = Datadir + 'overcheck'
if File::exist?(check_file) then
  # -- ֤ФƤ̵
  lasttime = Time::now - File::mtime(check_file)
  if lasttime < (60 * 5)
    fp = open(check_file)
    key = fp.readline
    fp.close
    if key =~ writeover_key then
      print "Content-type: text/html\n\n"
      print "<HTML>\n"
      print "<HEAD>\n"
      print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=x-euc\">"
      print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"10;URL="+PostDiarydone+"\">"
      print "</HEAD>\n"
      print "<body>"
      print "<A HREF=\""+PostDiarydone+"\">Return BBS.</A>"
      print "<P><HR><P>\n"
      print "Ž񤭹ߤ򸡽С򤷤ޤ\n"
      print "</body></html>\n"
      exit
    end
  end
end
fp = open(check_file, "w")
fp.print(writeover_key)
fp.close


# --- ƥν񤭹
if editmode == false then
  art.write_article
else
  art.edit_article
end

# --- ƥʤι
db.update_antenna(author, serial+1)

# --- 񤭹߽λ
return_url = PostDiarydone
print "Content-type: text/html\n\n"
print "<HTML>\n"
print "<HEAD>\n"
print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=x-euc\">"
print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"1;URL=./"+return_url+"\">"
print "</HEAD>\n"
print "<body>"
print "<A HREF=\"./"+return_url+"\">Request Accept.</A>"
print "</body></html>\n"


