#---------------------------------------------------
# Limo WEB-BBS System.
#   BrowserPhone ANZXr[A[eBN
#
#       1st Maintaner  rero2@fumi
#
#---------------------------------------------------

#------------------------------------
# XV
#
# Jun.05.2002 - rero2@fumi
#   
#----

#---------------------------------------------------
# e평
#---------------------------------------------------

require 'cgi'
require 'jcode'
require 'kconv'
require "config.rb"
require "bbs_database.rb"
require "bbs_article.rb"
require "bbs_hierarchy.rb"

$KCODE = 'SJIS'

# ------------------------------------------------------ #
#  Hierarchy Class                                       #
# ------------------------------------------------------ #


#---------------------------------------------
#----- qGL[NX
#
class  PhoneHierarchy < Hierarchy

  #-------------------------------------
  #--- RXgN^
  #  db = f[^x[XNX
  def initialize(db, max, id, page)
    # --- eNXɏ]
    super(db)
    if id == 0 then
      # --- y[WPʂŎo
      listup(max, (max * page))
    else
      art = PhoneArticle::new(@bbs_db)
      art.get_article(id - 1)
      @relation << art
      @length += 1
    end
  end


  #- - - - - 
  private

  #-------------------------------------
  #--- w肳ꂽXgAbv
  def listup(num, start)
    max = @bbs_db.length
    if start >= max then
      start = max - 1
    end
    if (start+num) < max then
      index = num + start
    else
      index = max
    end
    for i in start...index
      art = PhoneArticle::new(@bbs_db)
      art.get_article(max-i-1)
      @relation << art
      @length += 1
    end
  end

end


# ------------------------------------------------------ #
#  Article Class (& view)                                #
# ------------------------------------------------------ #

#---------------------------------------------
#----- gѓdbpA[eBNNX
#
class  PhoneArticle < ArticleClass

  Segment = 1000

  #-------------------------------------
  #--- RXgN^
  #  db = f[^x[XNX
  def initialize(db)
    # -----
    super(db)
    @a_talkblock = Array::new
  end


  #-------------------------------------
  #-- A[eBN̎擾
  def get_article(num)
    super(num)
    # --- SJIS ɕR[hϊ
    @a_author = Kconv::tosjis(@a_author)
    @a_title = Kconv::tosjis(@a_title)
    @a_topic = Kconv::tosjis(@a_topic)
    @a_email = Kconv::tosjis(@a_email)
    @a_homepage = Kconv::tosjis(@a_homepage)
    @a_reference = Kconv::tosjis(@a_reference)
    @a_talk = Kconv::tosjis(@a_talk)
    @a_topic.gsub!(/&#32;/, ' ')
    @a_parent.gsub!(/&#32;/, ' ')
    @a_title.gsub!(/&#32;/, ' ')
    @a_author.gsub!(/&#32;/, ' ')
    @a_email.gsub!(/&#32;/, ' ')
    @a_homepage.gsub!(/&#32;/, ' ')
    @a_reference.gsub!(/&#32;/, ' ')
    @a_icon.gsub!(/&#32;/, ' ')
    @a_talk.gsub!(/&#32;/, ' ')
    @a_reference.gsub!(/&#10;/, "<br>")
    @a_talk.gsub!(/&#10;/, "<br>")
    talkblock
  end


  #-------------------------------------
  #-- A[eBN{̂ubNԂ
  def length
    @a_talkblock.length - 1
  end


  #-------------------------------------
  #--- Phone title
  def html_article(page)
    output = ''
    # -- VAio[
    art_serial = sprintf("No.%06d\n", @a_serial)
    option = sprintf("?id=%s", @a_serial)
    if page.to_i > 0 then
      option << sprintf("&page=%d", page.to_i)
    end
    link_serial = sprintf("<A HREF=\"%s%s\">", BasePhoneurl, option)
    link_serial << art_serial
    link_serial << "</A>\n"
    output << link_serial
    output << "<br>\n"
    # --ݓ
    t = Time::at(@a_date)
    date = sprintf("%s", t.strftime("%b.%d %H:%M'%S"))
    output << sprintf("%s\n", date)
    output << "<br>\n"
    # -- 
    if @a_email == '' then
      output << sprintf("[%s]\n", @a_author)
    else
      output << sprintf("[<a href=\"mailto:%s\">\n", @a_email)
      output << sprintf("%s\n", @a_author)
      output << "</a>]\n"
    end
    output << "<br>\n"
    # -- L^Cg
    output << sprintf("%s\n", @a_title)
    output << "<br>\n"
    # -- f[^Ԃ
    output
  end


  #-------------------------------------
  #--- Phone talk L̎wy[WԂ
  def phone_article(page)
    output = ''
    # --
    output << @a_talkblock[page]
    # --
    output
  end


  private

  #--------------------------------------------
  #--
  def talkblock
    index = 0
    len = 0
    tagmode = FALSE
    @a_talkblock[index] = String::new('')
    chunk = String::new(@a_talk)
    chunk.each_char do |c|
      if tagmode == TRUE then
        @a_talkblock[index] << c
        if c == '>' then
          tagmode = FALSE
        end
      else
        @a_talkblock[index] << c
        if c == '<' then
          tagmode = TRUE
          next
        else
          len += 1
          len += 1 if c.size == 2
          if len > Segment then
            len = 0
            index += 1
	    @a_talkblock[index] = String::new('')
          end
        end
      end
    end
  end

end
