#---------------------------------------------------
# Limo WEB-BBS System.
#   ĥ꡼ѥҥ륭
#     ֿƤμˤäƤ
#     ֿޤưֿ¤٤
#
#     
#     1-+
#       |
#       7
#       |
#       3-+
#       | |
#       | 5-+
#       |   |
#       |   6
#       |
#       2-+
#         |
#         4
#     
#     1735624¤Ӥޤ
#
#       1st Maintaner  ruto
#---------------------------------------------------

#------------------------------------
# 
#
# Feb.03.2002 - ruto
#   ȤꤢäƤߤ
#   տޤֿ⿷ˤʤǤ(^^
#   äƤǤ
#----

#---------------------------------------------------
# 饤֥䳰ե
#---------------------------------------------------

require "config.rb"
require "bbs_database.rb"
require "bbs_article.rb"
require "bbs_hierarchy.rb"


# ------------------------------------------------------ #
#  Hierarchy Class                                       #
# ------------------------------------------------------ #


#---------------------------------------------
#----- Υ졼ѡ
#
class  TreeArticle < Hierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  #  num = ǿĤФ
  def initialize(db, num)
    # --- ƥ饹θƤӽФ
    super(db)
    # --- Ϣɤ߽Ф᥽å
    listup(num)
    # --- ƥϢȾ(Ƣ)Ĵ
    child_parse
  end

  #-------------------------------------
  #--- ȥĥ꡼ꥹȤɽ
  def disp_tree
    art = @relation[0]
    start_serial = art.serial
    for i in 0...@length
      art = @relation[i]
      if (art.get_delete == '') && 
         ((art.get_layer == '') || (art.get_layer == 'wikinote')) then
        if art.visible == true then
          link_topic = sprintf("<A HREF=\"%s?topic=%s\" CLASS=\"hide\">", Baseurl, 
                                CGI::escape(art.topic))
          link_topic << art.topic
          link_topic << "</A>\n"
          print "<p>\n"
          print "[Topic: "
          print link_topic
          print "] <br>\n"
          disp_node(i)
        end
      end
    end
  end

  #- - - - - ʲץ饤١ȥꥢ
  private

  #-------------------------------------
  #--- ǡŤФ
  def listup(num)
    max = @bbs_db.length
    if num < max then
      index = num
    else
      index = max
    end
    min = max - index
    for i in 0...index
      art = ArticleForTree::new(@bbs_db)
      art.get_article(min+i)
      @relation << art
      @length += 1
    end
  end

  #-------------------------------------
  #--- ĥ꡼ι¤Ϥΰ
  #    ҥƥθ򤹤
  def child_parse
    art = @relation[0]
    start_serial = art.serial
    for i in 0...@length
      next if i == 0
      art = @relation[i]
      self_serial = art.serial
      parent = art.parent
      parent_num = 0
      if parent =~ /@([0-9]+)/ then
        parent_num = $1.to_i
      end
      index = parent_num - start_serial
      if (index >= 0) && (index < @length) then
        p_art = @relation[index]
        p_art.set_child(self_serial - start_serial) unless p_art == nil
        art.level = p_art.level + 1
      end 
    end
  end

  #-------------------------------------
  #--- ȥĥ꡼κƵŪɽ
  def disp_node(num)
    art = @relation[num]
    unless art == nil then
      print art.html_article_title
      art.visible = false
      while(art.child.length > 0)
        child = art.child.shift
        disp_node(child)
      end
    end
  end

end


# ------------------------------------------------------ #
#  Article Class                                         #
# ------------------------------------------------------ #

#---------------------------------------------
#----- ĥ꡼¤ѥƥ륯饹
#
class  ArticleForTree < Article
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  def initialize(db)
    # ----- ѡ饹ν
    super(db)
    # ----- ĥ꡼ƥѤΥѡ
    # -- ֿ()Υꥢݻ
    @child = Array::new
    # -- ߤֿ٥
    @level = 0
    # -- о줷ɤΥե饰
    @visible = true
  end


  #-------------------------------------
  #--- ᥽åɷ
  def set_child(num)
    @child << num
  end
  def get_child
    @child
  end
  def child= num
    set_child(num)
  end
  def child
    get_child
  end
  # -
  def set_level(num)
    @level = num
  end
  def get_level
    @level
  end
  def level= num
    set_level(num)
  end
  def level
    get_level
  end
  # -
  def set_visible(flag)
    @visible = flag
  end
  def get_visible
    @visible
  end
  def visible= num
    set_visible(num)
  end
  def visible
    get_visible
  end
  # -


  #-------------------------------------
  #--- ȥ륪꡼Υĥ꡼ɽ
  def html_article_title
    output = ''
    link_tag = sprintf("<A HREF=\"%s?id=%d\" CLASS=\"hide\">", Baseurl, @a_serial)
    artnum = sprintf("No.%06d\n", @a_serial)
    t = Time::at(@a_date)
    date = sprintf("%s", t.strftime("%b.%d.%Y %H:%M'%S"))
    node = ''
    n = @level
    while(n > 0)
      node << '| '
      n -= 1
    end
    node << '+--' + "<br>\n" + node
    # -----
    # -- ơ֥
    output << '<table cellpadding="1" cellspacing="0" border="0" width="95%">'
    output << "\n"
    # -- ȥ
    output << "  <tr>\n"
    output << '    <td bgcolor="#ffffff">' + "\n"
    output << '      <font color="#505050">' + "\n"
    output << node
    output << "      </font>\n"     
    output << "    </td>\n"
    output << '    <td bgcolor="#ffffff">' + "\n"
    output << '      <font color="#505050">' + "\n"
    output << sprintf("        %s %s %s </a>\n", link_tag, artnum, @a_title)
    output << "<br>\n"
    output << sprintf("%s %s\n", @a_author, date)
    output << "      </font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # --
    output << "</table>\n"
    output
  end

end
