#---------------------------------------------------
# Limo WEB-BBS System.
#   Diary mode ѥҥ륭ӥ塼
#
#       1st Maintaner  rero2@fumi
#
#---------------------------------------------------

#------------------------------------
# 
#
# Sep.01.2002 - rero2@fumi
#   
#----

#---------------------------------------------------
# 饤֥䳰ե
#---------------------------------------------------

require 'cgi'
require "config.rb"
require "bbs_database.rb"
require "wikiview.rb"


# ------------------------------------------------------ #
#  Database Class                                        #
# ------------------------------------------------------ #

#---------------------------------------------
#----- Ѥ˥ƥʥեγĥ
#
class  Diarydb < Ezdb

  #-------------------------------------
  #--- ѥ᡼
  #  dir = ǡݴɥǥ쥯ȥ
  #  suffix = ե̾դ̾
  def initialize(dir, suffix)
    # --- ƥ饹θƤӽФ
    super(dir, suffix)
    # --- 饹ѿ
    @diary_antenna = dir + "/diary_antenna.dat"
    @diary_antenna.gsub!(/\/\//, '/')
  end

  #-------------------------------------
  #--- 桼οϿ
  def add_user(username, crypt, mail, title)
    # --- ǡ١åΥå
    while(lock_check == 1)
      sleep(0.5)
    end
    # -- ǡ١å
    lock
    # -- ߤΥꥹ
    fp = open(DiaryUser, "r")
    list = Array::new
    list.clear
    fp.each_line do |line|
      list << line
    end
    fp.close
    # -- ɵ
    list << sprintf("%s %s %s %s\n", username, crypt, mail, title);
    fp = open(DiaryUser, "w")
    list.each do |line|
      fp.print(line)
    end
    fp.close
    # -- ǡ١å
    unlock
  end


  #-------------------------------------
  #--- 桼ꥹȤ
  def user_list
    # -- ߤΥꥹ
    fp = open(DiaryUser, "r")
    list = Array::new
    list.clear
    fp.each_line do |line|
      parts = line.split
      list << parts[0]
    end
    fp.close
    # -- 
    list
  end


  #-------------------------------------
  #--- 桼Ͽɤ߹
  def user_info(user)
    r = nil
    # -- ߤΥꥹ
    fp = open(DiaryUser, "r")
    list = Array::new
    list.clear
    fp.each_line do |line|
      list << line
    end
    fp.close
    # -- 桼õ
    list.each do |line|
      parts = line.split
      if parts[0] == user then
        r = parts
        break
      end
    end
    # -- 
    r
  end


  #-------------------------------------
  #--- ƥʥե빹
  def update_antenna(user, serial)
    # -- ߤΥꥹ
    fp = open(@diary_antenna, "r")
    list = Array::new
    list.clear
    fp.each_line do |line|
      list << line
    end
    # -- ǡ١åΥå
    while(lock_check == 1)
      sleep(0.5)
    end
    # -- ǡ١å
    lock
    # -- 񤭽Ф
    t = Time::now
    date = sprintf("%s %d %d\n", user, serial, t.to_i)
    fp = open(@diary_antenna, "w")
    fp.print(date)
    list.each do |line|
      parts = line.split
      if parts[0] != user then
        fp.print(line)
      end
    end
    fp.close
    # -- ǡ١å
    unlock
  end


  #-------------------------------------
  #--- ƥʤɤ߹
  def antenna(user)
    r = nil
    # -- ߤΥꥹ
    fp = open(@diary_antenna, "r")
    list = Array::new
    list.clear
    fp.each_line do |line|
      list = line.split
      if list[0] == user then
        r = list
        break
      end
    end
    # -- 
    r
  end

end


# ------------------------------------------------------ #
#  Hierarchy Class                                       #
# ------------------------------------------------------ #

#---------------------------------------------
#----- 桼Ϥ
#
class  DiaryHierarchy < WikiHierarchy
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  #  author =  author
  def initialize(db, diary_author)
    # --- ƥ饹θƤӽФ
    super(db)
    @diarydb = db
    @author = diary_author
  end

  #-------------------------------------
  #--- ƥ
  def length
    l = 0
    at = @diarydb.antenna(@author)
    if at != nil then
      l = l + 1
      startnum = at[1].to_i
      art = DiaryArticle::new(@diarydb)
      art.get_article(startnum - 1)
      while art.parent != '' do
        l = l + 1
        art.parent =~ /@([0-9]+)/
        num = $1.to_i
        unless num == 0 then
          art2 = DiaryArticle::new(@diarydb)
          art2.get_article(num - 1)
          break if art2.parent == ''
          art = art2 
        end
      end
    end
    # -- 
    l
  end


  #-------------------------------------
  #--- ɤ߽Ф
  #  num = ǿĤФ
  #  page = ɽڡ(0 Ǻǿ)
  def get_diary(num, page)
    artlist = Array::new
    start_index = num * page
    at = @diarydb.antenna(@author)
    if at != nil then
      startnum = at[1].to_i
      article = DiaryArticle::new(@diarydb)
      article.get_article(startnum - 1)
      # -- Ф
      if start_index > 0 then
        for i in 0..(start_index - 1) do
          a2 = get_parent(article)
          break if a2 == nil
          article = a2
        end
      end
      # -- ɤ߹
      for i in 0..(num - 1) do
        if article == nil then
          break
        end
        artlist << article
        a2 = get_parent(article)
        break if a2 == nil
        article = a2
      end
    end
    # -- 
    artlist
  end

  # - - - - - - - - - - - - -
 private
  def get_parent(article)
    article2 = nil
    if article.parent != '' then
      article.parent =~ /@([0-9]+)/
      num = $1.to_i
      unless num == 0 then
        article2 = DiaryArticle::new(@diarydb)
        article2.get_article(num - 1)
      end
    end
    # -- 
    article2
  end

end


# ------------------------------------------------------ #
#  Article Class (& view)                                #
# ------------------------------------------------------ #

#---------------------------------------------
#----- ƥ륯饹
#
class  DiaryArticle < WikiArticle
  #-------------------------------------
  #--- ѥ᡼
  #  db = ǡ١֥
  def initialize(db)
    # ----- ѡ饹ν
    super(db)
  end


  #-------------------------------------
  #--- Diary ڡΥ
  def html_article
    output = ''
    # -- ơ֥
    output << '<table cellpadding="2" cellspacing="1" border="0" width="90%">'
    output << "\n"
    # -- ƥ륿ȥ
    art_serial = sprintf("No.%06d\n", @a_serial)
    link_serial = sprintf("<A HREF=\"%s?id=%d\" CLASS=\"hide\">", Baseurl, @a_serial)
    link_serial << art_serial
    link_serial << "</A>\n"
    output << "  <tr>\n"
    output << '    <td bgcolor="#c0ffa0" width="24%">' + "\n"
    output << '      <font color="#000000"><b>' + "\n"
    output << link_serial
    output << "      </b></font>\n"     
    output << "    </td>\n"
    output << '    <td bgcolor="#409040" width="76%">' + "\n"
    output << '      <font color="#ffffff" size="+1"><b>' + "\n"
    output << sprintf("        %s\n", @a_title)
    output << "      </b></font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # -- Ҽ
    output << "  <tr>\n"
    output << '    <td bgcolor="#e0ffc0">' + "\n"
    output << '      <font color="#505050">' + "\n"
    output << "        Author :\n"
    output << "      </font>\n"     
    output << "    </td>\n"
    output << '    <td bgcolor="#ffffff">' + "\n"
    output << '      <font color="#000000">' + "\n"
    output << sprintf("        %s\n", @a_author)
    output << "      </font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # -- 񤭹
    t = Time::at(@a_date)
    date = sprintf("%s", t.strftime("%b.%d.%Y %H:%M'%S"))
    output << "  <tr>\n"
    output << '    <td bgcolor="#e0ffc0">' + "\n"
    output << '      <font color="#505050">' + "\n"
    output << "        Date :\n"
    output << "      </font>\n"     
    output << "    </td>\n"
    output << '    <td bgcolor="#ffffff">' + "\n"
    output << '      <font color="#000000">' + "\n"
    output << sprintf("        %s\n", date)
    output << "      </font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # -- ȡ
    unless @a_reference == '' then
      tmp = @a_reference
      tmp.gsub(/\n/, "<br>\n")
      output << "  <tr>\n"
      output << '    <td bgcolor="#e0ffc0">' + "\n"
      output << '      <font color="#505050">' + "\n"
      output << "        Reference :\n"
      output << "      </font>\n"     
      output << "    </td>\n"
      output << '    <td bgcolor="#ffffff">' + "\n"
      output << '      <font color="#000000">' + "\n"
      output << sprintf("        %s\n", autolink(tmp))
      output << "      </font>\n"     
      output << "    </td>\n"
      output << "  </tr>\n"
    end
    # -- Υȥԥå
    link_topic = sprintf("<A HREF=\"%s?topic=%s\" CLASS=\"hide\">", Baseurl, 
                          CGI::escape(@a_topic))
    link_topic << @a_topic
    link_topic << "</A>\n"
    output << "  <tr>\n"
    output << '    <td bgcolor="#e0ffc0">' + "\n"
    output << '      <font color="#505050">' + "\n"
    output << "        Topic :\n"
    output << "      </font>\n"     
    output << "    </td>\n"
    output << '    <td bgcolor="#ffffff">' + "\n"
    output << '      <font color="#000000">' + "\n"
    output << link_topic
    output << "      </font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # -- ѹ
    unless @a_edit == '' then
      tmp = @a_edit
      tmp.gsub!(/&#10;/, "<br>\n")
      output << "  <tr>\n"
      output << '    <td bgcolor="#e0ffc0">' + "\n"
      output << '      <font color="#505050">' + "\n"
      output << "        Edit history :\n"
      output << "      </font>\n"     
      output << "    </td>\n"
      output << '    <td bgcolor="#ffffff">' + "\n"
      output << '      <font color="#000000">' + "\n"
      output << sprintf("        %s\n", tmp)
      output << "      </font>\n"     
      output << "    </td>\n"
      output << "  </tr>\n"
    end
    # -- ƥ
    tmp = @a_talk
    tmp.gsub!(/&#10;/, "<br>")
    tmp.gsub!(/&#32;/, ' ')
    output << "  <tr>\n"
    output << '    <td colspan="2" bgcolor="#f0fff0">' + "\n"
    output << '      <font color="#404040">' + "\n"
    output << sprintf("        %s\n", make_wikilink(autolink(tmp)))
    output << "      </font>\n"     
    output << "    </td>\n"
    output << "  </tr>\n"
    # -- ޤ
    output << "</table>\n"
    output
  end

end
